=== modified file 'drizzled/field/datetime.cc'
--- drizzled/field/datetime.cc	2009-02-28 20:43:31 +0000
+++ drizzled/field/datetime.cc	2009-03-01 03:08:20 +0000
@@ -45,37 +45,6 @@
                           uint32_t len,
                           const CHARSET_INFO * const )
 {
-#ifdef NOTDEFINED
-  DRIZZLE_TIME time_tmp;
-  int error;
-  uint64_t tmp= 0;
-  enum enum_drizzle_timestamp_type func_res;
-  Session *session= table ? table->in_use : current_session;
-
-  func_res= str_to_datetime(from, len, &time_tmp,
-                            (TIME_FUZZY_DATE |
-                             (session->variables.sql_mode &
-                              (MODE_NO_ZERO_DATE | MODE_INVALID_DATES))),
-                            &error);
-  if ((int) func_res > (int) DRIZZLE_TIMESTAMP_ERROR)
-    tmp= TIME_to_uint64_t_datetime(&time_tmp);
-  else
-    error= 1;                                 // Fix if invalid zero date
-
-  if (error)
-    set_datetime_warning(DRIZZLE_ERROR::WARN_LEVEL_WARN,
-                         ER_WARN_DATA_OUT_OF_RANGE,
-                         from, len, DRIZZLE_TIMESTAMP_DATETIME, 1);
-
-#ifdef WORDS_BIGENDIAN
-  if (table && table->s->db_low_byte_first)
-  {
-    int8store(ptr,tmp);
-  }
-  else
-#endif
-    int64_tstore(ptr,tmp);
-#endif /* NOTDEFINED */
   /* 
    * Try to create a DateTime from the supplied string.  Throw an error
    * if unable to create a valid DateTime.  

=== modified file 'drizzled/field/timestamp.cc'
--- drizzled/field/timestamp.cc	2009-02-28 20:43:31 +0000
+++ drizzled/field/timestamp.cc	2009-03-01 03:08:20 +0000
@@ -25,6 +25,9 @@
 #include <drizzled/tztime.h>
 #include <drizzled/table.h>
 #include <drizzled/session.h>
+
+#include "drizzled/temporal.h"
+
 #include CMATH_H
 
 #if defined(CMATH_NAMESPACE)
@@ -74,7 +77,6 @@
   course is non-standard.) In most cases user won't notice any change, only
   exception is different behavior of old/new timestamps during ALTER TABLE.
  */
-
 Field_timestamp::Field_timestamp(unsigned char *ptr_arg,
                                  uint32_t ,
                                  unsigned char *null_ptr_arg, unsigned char null_bit_arg,
@@ -97,7 +99,6 @@
   }
 }
 
-
 Field_timestamp::Field_timestamp(bool maybe_null_arg,
                                  const char *field_name_arg,
                                  const CHARSET_INFO * const cs)
@@ -111,7 +112,6 @@
       flags|= ON_UPDATE_NOW_FLAG;
 }
 
-
 /**
   Get auto-set type for TIMESTAMP field.
 
@@ -214,117 +214,75 @@
 int64_t Field_timestamp::val_int(void)
 {
   uint32_t temp;
-  DRIZZLE_TIME time_tmp;
-  Session  *session= table ? table->in_use : current_session;
 
 #ifdef WORDS_BIGENDIAN
   if (table && table->s->db_low_byte_first)
-    temp=uint4korr(ptr);
+    temp= uint4korr(ptr);
   else
 #endif
-    longget(temp,ptr);
-
-  if (temp == 0L)				// No time
-    return(0);					/* purecov: inspected */
-
-  session->variables.time_zone->gmt_sec_to_TIME(&time_tmp, (time_t)temp);
-
-  return time_tmp.year * INT64_C(10000000000) +
-         time_tmp.month * INT64_C(100000000) +
-         time_tmp.day * 1000000 + time_tmp.hour * 10000 +
-         time_tmp.minute * 100 + time_tmp.second;
+    longget(temp, ptr);
+
+  drizzled::Timestamp temporal;
+  (void) temporal.from_time_t((time_t) temp);
+
+  /* We must convert into a "timestamp-formatted integer" ... */
+  int64_t result;
+  temporal.to_int64_t(&result);
+  return result;
 }
 
-String *Field_timestamp::val_str(String *val_buffer, String *val_ptr)
+String *Field_timestamp::val_str(String *val_buffer, String *)
 {
-  uint32_t temp, temp2;
-  DRIZZLE_TIME time_tmp;
-  Session *session= table ? table->in_use : current_session;
+  uint32_t temp;
   char *to;
 
-  val_buffer->alloc(field_length+1);
-  to= (char*) val_buffer->ptr();
-  val_buffer->length(field_length);
+  val_buffer->alloc(field_length + 1);
+  to= (char *) val_buffer->ptr();
 
 #ifdef WORDS_BIGENDIAN
   if (table && table->s->db_low_byte_first)
-    temp=uint4korr(ptr);
+    temp= uint4korr(ptr);
   else
 #endif
-    longget(temp,ptr);
-
-  if (temp == 0L)
-  {				      /* Zero time is "000000" */
-    val_ptr->set(STRING_WITH_LEN("0000-00-00 00:00:00"), &my_charset_bin);
-    return val_ptr;
-  }
-  val_buffer->set_charset(&my_charset_bin);	// Safety
-
-  session->variables.time_zone->gmt_sec_to_TIME(&time_tmp,(time_t)temp);
-
-  temp= time_tmp.year % 100;
-  if (temp < YY_PART_YEAR - 1)
-  {
-    *to++= '2';
-    *to++= '0';
-  }
-  else
-  {
-    *to++= '1';
-    *to++= '9';
-  }
-  temp2=temp/10; temp=temp-temp2*10;
-  *to++= (char) ('0'+(char) (temp2));
-  *to++= (char) ('0'+(char) (temp));
-  *to++= '-';
-  temp=time_tmp.month;
-  temp2=temp/10; temp=temp-temp2*10;
-  *to++= (char) ('0'+(char) (temp2));
-  *to++= (char) ('0'+(char) (temp));
-  *to++= '-';
-  temp=time_tmp.day;
-  temp2=temp/10; temp=temp-temp2*10;
-  *to++= (char) ('0'+(char) (temp2));
-  *to++= (char) ('0'+(char) (temp));
-  *to++= ' ';
-  temp=time_tmp.hour;
-  temp2=temp/10; temp=temp-temp2*10;
-  *to++= (char) ('0'+(char) (temp2));
-  *to++= (char) ('0'+(char) (temp));
-  *to++= ':';
-  temp=time_tmp.minute;
-  temp2=temp/10; temp=temp-temp2*10;
-  *to++= (char) ('0'+(char) (temp2));
-  *to++= (char) ('0'+(char) (temp));
-  *to++= ':';
-  temp=time_tmp.second;
-  temp2=temp/10; temp=temp-temp2*10;
-  *to++= (char) ('0'+(char) (temp2));
-  *to++= (char) ('0'+(char) (temp));
-  *to= 0;
+    longget(temp, ptr);
+
+  val_buffer->set_charset(&my_charset_bin);	/* Safety */
+
+  drizzled::Timestamp temporal;
+  (void) temporal.from_time_t((time_t) temp);
+  size_t to_len;
+
+  temporal.to_string(to, &to_len);
+  val_buffer->length((uint32_t) to_len);
   return val_buffer;
 }
 
-bool Field_timestamp::get_date(DRIZZLE_TIME *ltime, uint32_t fuzzydate)
+bool Field_timestamp::get_date(DRIZZLE_TIME *ltime, uint32_t)
 {
-  long temp;
-  Session *session= table ? table->in_use : current_session;
+  uint32_t temp;
+
 #ifdef WORDS_BIGENDIAN
   if (table && table->s->db_low_byte_first)
-    temp=uint4korr(ptr);
+    temp= uint4korr(ptr);
   else
 #endif
-    longget(temp,ptr);
-  if (temp == 0L)
-  {				      /* Zero time is "000000" */
-    if (fuzzydate & TIME_NO_ZERO_DATE)
-      return 1;
-    memset(ltime, 0, sizeof(*ltime));
-  }
-  else
-  {
-    session->variables.time_zone->gmt_sec_to_TIME(ltime, (time_t)temp);
-  }
+    longget(temp, ptr);
+  
+  memset(ltime, 0, sizeof(*ltime));
+
+  drizzled::Timestamp temporal;
+  (void) temporal.from_time_t((time_t) temp);
+
+  /* @TODO Goodbye the below code when DRIZZLE_TIME is finally gone.. */
+
+  ltime->time_type= DRIZZLE_TIMESTAMP_DATETIME;
+  ltime->year= temporal.years();
+  ltime->month= temporal.months();
+  ltime->day= temporal.days();
+  ltime->hour= temporal.hours();
+  ltime->minute= temporal.minutes();
+  ltime->second= temporal.seconds();
+
   return 0;
 }
 
@@ -372,13 +330,11 @@
   }
 }
 
-
 void Field_timestamp::sql_type(String &res) const
 {
   res.set_ascii(STRING_WITH_LEN("timestamp"));
 }
 
-
 void Field_timestamp::set_time()
 {
   Session *session= table ? table->in_use : current_session;
@@ -387,7 +343,6 @@
   store_timestamp(tmp);
 }
 
-
 void Field_timestamp::set_default()
 {
   if (table->timestamp_field == this &&
@@ -410,7 +365,6 @@
   return tmp;
 }
 
-
 void Field_timestamp::store_timestamp(time_t timestamp)
 {
 #ifdef WORDS_BIGENDIAN
@@ -422,4 +376,3 @@
 #endif
     longstore(ptr,(uint32_t) timestamp);
 }
-

=== modified file 'drizzled/function/time/curdate.cc'
--- drizzled/function/time/curdate.cc	2009-02-14 19:02:06 +0000
+++ drizzled/function/time/curdate.cc	2009-03-01 03:08:20 +0000
@@ -52,8 +52,16 @@
 void Item_func_curdate_local::store_now_in_TIME(DRIZZLE_TIME *now_time)
 {
   Session *session= current_session;
-  session->variables.time_zone->gmt_sec_to_TIME(now_time,
-                                                (time_t)session->query_start());
+  time_t tmp= session->query_start();
+
+  (void) cached_temporal.from_time_t(tmp);
+
+  now_time->year= cached_temporal.years();
+  now_time->month= cached_temporal.months();
+  now_time->day= cached_temporal.days();
+  now_time->hour= 0;
+  now_time->minute= 0;
+  now_time->second= 0;
 }
 
 /**
@@ -62,12 +70,17 @@
 */
 void Item_func_curdate_utc::store_now_in_TIME(DRIZZLE_TIME *now_time)
 {
-  my_tz_UTC->gmt_sec_to_TIME(now_time,
-                             (time_t)(current_session->query_start()));
-  /*
-    We are not flagging this query as using time zone, since it uses fixed
-    UTC-SYSTEM time-zone.
-  */
+  Session *session= current_session;
+  time_t tmp= session->query_start();
+
+  (void) cached_temporal.from_time_t(tmp);
+
+  now_time->year= cached_temporal.years();
+  now_time->month= cached_temporal.months();
+  now_time->day= cached_temporal.days();
+  now_time->hour= 0;
+  now_time->minute= 0;
+  now_time->second= 0;
 }
 
 bool Item_func_curdate::get_temporal(drizzled::Date &to)

=== modified file 'drizzled/function/time/curdate.h'
--- drizzled/function/time/curdate.h	2009-02-14 19:02:06 +0000
+++ drizzled/function/time/curdate.h	2009-03-01 03:08:20 +0000
@@ -26,6 +26,7 @@
 /* Abstract CURDATE function. See also Item_func_curtime. */
 class Item_func_curdate :public Item_date
 {
+protected:
   DRIZZLE_TIME ltime;
   drizzled::Date cached_temporal;
 public:

=== modified file 'drizzled/function/time/now.cc'
--- drizzled/function/time/now.cc	2009-02-28 20:43:31 +0000
+++ drizzled/function/time/now.cc	2009-03-01 03:08:20 +0000
@@ -20,9 +20,10 @@
 #include <drizzled/server_includes.h>
 #include CSTDINT_H
 #include <drizzled/function/time/now.h>
-#include <drizzled/tztime.h>
 #include <drizzled/session.h>
 
+#include "drizzled/temporal.h"
+
 String *Item_func_now::val_str(String *)
 {
   assert(fixed == 1);
@@ -54,8 +55,16 @@
 void Item_func_now_local::store_now_in_TIME(DRIZZLE_TIME *now_time)
 {
   Session *session= current_session;
-  session->variables.time_zone->gmt_sec_to_TIME(now_time,
-                                                (time_t)session->query_start());
+  time_t tmp= session->query_start();
+
+  (void) cached_temporal.from_time_t(tmp);
+
+  now_time->year= cached_temporal.years();
+  now_time->month= cached_temporal.months();
+  now_time->day= cached_temporal.days();
+  now_time->hour= cached_temporal.hours();
+  now_time->minute= cached_temporal.minutes();
+  now_time->second= cached_temporal.seconds();
 }
 
 
@@ -65,12 +74,23 @@
 */
 void Item_func_now_utc::store_now_in_TIME(DRIZZLE_TIME *now_time)
 {
-  my_tz_UTC->gmt_sec_to_TIME(now_time,
-                             (time_t)(current_session->query_start()));
-  /*
-    We are not flagging this query as using time zone, since it uses fixed
-    UTC-SYSTEM time-zone.
-  */
+  Session *session= current_session;
+  time_t tmp= session->query_start();
+
+  (void) cached_temporal.from_time_t(tmp);
+
+  now_time->year= cached_temporal.years();
+  now_time->month= cached_temporal.months();
+  now_time->day= cached_temporal.days();
+  now_time->hour= cached_temporal.hours();
+  now_time->minute= cached_temporal.minutes();
+  now_time->second= cached_temporal.seconds();
+}
+
+bool Item_func_now::get_temporal(drizzled::DateTime &to)
+{
+  to= cached_temporal;
+  return true;
 }
 
 bool Item_func_now::get_date(DRIZZLE_TIME *res,

=== modified file 'drizzled/function/time/now.h'
--- drizzled/function/time/now.h	2009-01-23 06:12:21 +0000
+++ drizzled/function/time/now.h	2009-03-01 03:08:20 +0000
@@ -22,6 +22,8 @@
 
 #include <drizzled/function/time/date.h>
 
+#include "drizzled/temporal.h"
+
 /* Abstract CURRENT_TIMESTAMP function. See also Item_func_curtime */
 
 class Item_func_now :public Item_date_func
@@ -31,6 +33,7 @@
   char buff[20*2+32];   // +32 to make my_snprintf_{8bit|ucs2} happy
   uint32_t buff_length;
   DRIZZLE_TIME ltime;
+  drizzled::DateTime cached_temporal;
 public:
   Item_func_now() :Item_date_func() {}
   Item_func_now(Item *a) :Item_date_func(a) {}
@@ -39,6 +42,16 @@
   int save_in_field(Field *to, bool no_conversions);
   String *val_str(String *str);
   void fix_length_and_dec();
+  /**
+   * For NOW() and sisters, there is no argument, and we 
+   * return a cached Date value that we create during fix_length_and_dec.
+   *
+   * Always returns true, since a DateTime can always be constructed
+   * from a time_t
+   *
+   * @param Reference to a drizzled::DateTime to populate
+   */
+  bool get_temporal(drizzled::DateTime &temporal);
   bool get_date(DRIZZLE_TIME *res, uint32_t fuzzy_date);
   virtual void store_now_in_TIME(DRIZZLE_TIME *now_time)=0;
   bool check_vcol_func_processor(unsigned char *)

=== modified file 'tests/r/func_time.result'
--- tests/r/func_time.result	2009-02-28 20:43:31 +0000
+++ tests/r/func_time.result	2009-03-01 03:08:20 +0000
@@ -657,11 +657,11 @@
 select last_day("1997-12-1")+0.0;
 last_day("1997-12-1")+0.0
 19971231.0
-select strcmp(date_sub(localtimestamp(), interval 3 hour), utc_timestamp())=0;
-strcmp(date_sub(localtimestamp(), interval 3 hour), utc_timestamp())=0
-0
-select strcmp(date_format(date_sub(localtimestamp(), interval 3 hour),"%Y-%m-%d"), utc_date())=0;
-strcmp(date_format(date_sub(localtimestamp(), interval 3 hour),"%Y-%m-%d"), utc_date())=0
+select strcmp(date_sub(localtimestamp(), interval 0 hour), utc_timestamp())=0;
+strcmp(date_sub(localtimestamp(), interval 0 hour), utc_timestamp())=0
+1
+select strcmp(date_format(date_sub(localtimestamp(), interval 0 hour),"%Y-%m-%d"), utc_date())=0;
+strcmp(date_format(date_sub(localtimestamp(), interval 0 hour),"%Y-%m-%d"), utc_date())=0
 1
 select strcmp(date_format(utc_timestamp(),"%Y-%m-%d"), utc_date())=0;
 strcmp(date_format(utc_timestamp(),"%Y-%m-%d"), utc_date())=0

=== modified file 'tests/suite/vcol/r/vcol_supported_sql_funcs_innodb.result'
--- tests/suite/vcol/r/vcol_supported_sql_funcs_innodb.result	2009-02-28 20:43:31 +0000
+++ tests/suite/vcol/r/vcol_supported_sql_funcs_innodb.result	2009-03-01 03:08:20 +0000
@@ -2236,7 +2236,7 @@
 insert into t1 values ('2003-02-01','2003-05-01',default);
 select * from t1;
 a	b	c
-2003-02-01 00:00:00	2003-05-01 00:00:00	2
+2003-02-01 00:00:00	2003-05-01 00:00:00	3
 drop table t1;
 set sql_warnings = 0;
 # TO_DAYS()

=== modified file 'tests/t/func_time.test'
--- tests/t/func_time.test	2009-02-28 20:43:31 +0000
+++ tests/t/func_time.test	2009-03-01 03:08:20 +0000
@@ -381,8 +381,8 @@
 # Test SAPDB UTC_% functions. This part is TZ dependant (It is supposed that
 # TZ variable set to GMT-3
 
-select strcmp(date_sub(localtimestamp(), interval 3 hour), utc_timestamp())=0;
-select strcmp(date_format(date_sub(localtimestamp(), interval 3 hour),"%Y-%m-%d"), utc_date())=0;
+select strcmp(date_sub(localtimestamp(), interval 0 hour), utc_timestamp())=0;
+select strcmp(date_format(date_sub(localtimestamp(), interval 0 hour),"%Y-%m-%d"), utc_date())=0;
 select strcmp(date_format(utc_timestamp(),"%Y-%m-%d"), utc_date())=0;
 
 explain extended select period_add("9602",-12),period_diff(199505,"9404"),from_days(to_days("960101")),dayofmonth("1997-01-02"), month("1997-01-02"), monthname("1972-03-04"),dayofyear("0000-00-00"),HOUR("1997-03-03 23:03:22"),MINUTE("23:03:22"),SECOND(230322),QUARTER(980303),weekday(curdate())-weekday(now()),dayname("1962-03-03"),unix_timestamp(),curdate(),utc_date(),utc_timestamp(),date_format("1997-01-02 03:04:05", "%M %W %D %Y %y %m %d %h %i %s %w"),from_unixtime(unix_timestamp("1994-03-02 10:11:12")),"1997-12-31 23:59:59" + INTERVAL 1 SECOND,"1998-01-01 00:00:00" - INTERVAL 1 SECOND,INTERVAL 1 DAY + "1997-12-31", extract(YEAR FROM "1999-01-02 10:11:12"),date_add("1997-12-31 23:59:59",INTERVAL 1 SECOND);

